local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')

-- local labelType = 2 -- 1 = text, 2 = icon, 3 = icon + text
local lastPanel
local displayString = "---"
local _hex
local red = "|cffc74040"
local orange = "|cffda8c4f"
local SkillName, icon, SkillLevel, numSkills, SkillMaxLevel, SkillModifier, specIndex, specOffset
local profession, ProfAbbr, BonusRace, racial;
local iconnone = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\inv_misc_QuestionMark')
local iconArch = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\trade_archaeology')
local iconcook = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\inv_misc_food_15')
local iconfaid = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\spell_holy_sealofsacrifice')
local iconfish = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\trade_fishing')

local p1 = {"Prof 1", 'Interface\\Icons\\inv_misc_QuestionMark', 0, 0, 0, 0, 0, 0, 0, 0}
local p2 = {"Prof 2", 'Interface\\Icons\\inv_misc_QuestionMark', 0, 0, 0, 0, 0, 0, 0, 0}
local p3 = {"Archaeology", 'Interface\\Icons\\trade_archaeology', 0, 0, 0, 0, 0, 0, 0, 0}
local p4 = {"Cooking", 'Interface\\Icons\\inv_misc_food_15', 0, 0, 0, 0, 0, 0, 0, 0}
local p5 = {"First Aid", 'Interface\\Icons\\spell_holy_sealofsacrifice', 0, 0, 0, 0, 0, 0, 0, 0}
local p6 = {"Fishing", 'Interface\\Icons\\trade_fishing', 0, 0, 0, 0, 0, 0, 0, 0}

local MAX = 6
local SkillCap = 800;
local race = E.myrace

V['ElvUI_CompactProfessions'] = {
	['prof1'] = true or false,
	['prof2'] = true or false,
	['archaeology'] = true or false,
	['cooking'] = true or false,
	['firstaid'] = true or false,
	['fishing'] = true or false,
	['icons'] = true or false,
}

local function ToggleOption(name)
	if E.private['ElvUI_CompactProfessions'][name] then
		E.private['ElvUI_CompactProfessions'][name] = false
	else
		E.private['ElvUI_CompactProfessions'][name] = true
	end
end

local function GetOption(name)
	if E.private['ElvUI_CompactProfessions'] then
		return E.private['ElvUI_CompactProfessions'][name]
	end
end

local menu = {
	{ text = 'ElvUI Compact Professions Options', isTitle = true , notCheckable = true },
	{ text = 'Show First primary', checked = function() return GetOption('prof1') end, func = function() ToggleOption('prof1') end },
	{ text = 'Show Second Primary', checked = function()  return GetOption('prof2') end, func = function() ToggleOption('prof2') end },
	{ text = 'Show Archaeology', checked = function() return GetOption('archaeology') end, func = function() ToggleOption('archaeology') end },
	{ text = 'Show Cooking', checked = function() return GetOption('cooking') end, func = function() ToggleOption('cooking') end },
	{ text = 'Show First Aid', checked = function() return GetOption('firstaid') end, func = function() ToggleOption('firstaid') end },
	{ text = 'Show Fishing', checked = function() return GetOption('fishing') end, func = function() ToggleOption('fishing') end },
	{ text = 'Show Icons', checked = function() return GetOption('icons') end, func = function() ToggleOption('icons') end },
}

local menuFrame = CreateFrame("Frame", "ElvUI_CompatProfessionsMenuFrame", E.UIParent, 'UIDropDownMenuTemplate')

local function GetBonusRace(prof, num)
	if prof == "Alchemy" then
		BonusRace = "Goblin"
		Racial = 15
	elseif prof == "Enchanting" then
		BonusRace = "Blood Elf"
		Racial = 10
	elseif prof == "Engineering" then
		BonusRace = "Gnome"
		Racial = 15
	elseif prof == "Jewelcrafting" then
		BonusRace = "Draenei"
		Racial = 10
	elseif prof == "Skinning" then
		BonusRace = "Worgen"
		Racial = 15
	elseif prof == "Archaeology" then
		BonusRace = "Dwarf"
		Racial = 0
	elseif prof == "Cooking" then
		BonusRace = "Pandaren"
		Racial = 15
	else
		BonusRace = nil
		Racial = 0
	end
	
	if num == 1 then return BonusRace
	elseif num == 2 then return Racial
	end
end

local function ColorValue(name, bRrace, bonus, skill, skillmax, skillcap)
	local color

	if skill == nil and skilmax == nil then
		color = _hex
	elseif (race == bRace and skill >= (skillmax - bonus) - 25 and (skillmax + bonus) < (skillcap + bonus)) or (skill >= skillmax - 25 and skillmax < SkillCap) then	
		color = red
	else 
		color = _hex
	end

	return color
end

local function OnEvent(self, event, ...)
	lastPanel = self
	local prof1, prof2, archaeology, fishing, cooking, firstAid = GetProfessions();
	local profs = {prof1, prof2, archaeology, cooking, firstAid, fishing}
	local str
	local _text = "---"
	if not _hex then return end
	displayString = ''
	
	if prof1 ~= nil then
		local str
		local name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof1)
		if maxRank ~= nil then
			p1 = {name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset}
			if GetOption('prof1') then  -- if(i ~= 1) then _text = " " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,3)
				end
				if GetOption('icons') then
					str = tostring(texture..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				else
					str = tostring(_text..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				end
				displayString = displayString..str
			end
		end
	else
		if GetOption('prof1') then
			str = tostring(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\inv_misc_QuestionMark').._hex.."N/A".._hex.."|r  ")
			displayString = displayString..str
		end
	end
	if prof2 ~= nil then
		local str
		local name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset = GetProfessionInfo(prof2)
		if maxRank ~= nil then
			p2 = {name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset}
			if GetOption('prof2') then  -- if(i ~= 1) then _text = " " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,3)
				end
				if GetOption('icons') then
					str = tostring(texture..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				else
					str = tostring(_text..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				end
				displayString = displayString..str
			end
		end
	else
		if GetOption('prof2') then
			str = tostring(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\inv_misc_QuestionMark').._hex.."N/A".._hex.."|r  ")
			displayString = displayString..str
		end
	end
	if archaeology ~= nil then
		local name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset = GetProfessionInfo(archaeology)
		if maxRank ~= nil then
			p3 = {name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset}
			if GetOption('archaeology') then  -- if(i ~= 1) then _text = " " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,3)
				end
				if GetOption('icons') then
					str = tostring(texture..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				else
					str = tostring(_text..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				end
				displayString = displayString..str
			end
		end
	else
		if GetOption('archaeology') then
			str = tostring(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\trade_archaeology').._hex.."N/A".._hex.."|r  ")
			displayString = displayString..str
		end
	end
	if cooking ~= nil then
		local name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset = GetProfessionInfo(cooking)
		if maxRank ~= nil then
			p4 = {name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset}
			if GetOption('cooking') then  -- if(i ~= 1) then _text = " " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,3)
				end
				if GetOption('icons') then
					str = tostring(texture..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				else
					str = tostring(_text..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				end
				displayString = displayString..str
			end
		end
	else
		if GetOption('cooking') then
			str = tostring(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\inv_misc_food_15').._hex.."N/A".._hex.."|r  ")
			displayString = displayString..str
		end
	end
	if firstAid ~= nil then
		local name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset = GetProfessionInfo(firstAid)
		if maxRank ~= nil then
			p5 = {name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset}
			if GetOption('firstaid') then  -- if(i ~= 1) then _text = " " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,3)
				end
				if GetOption('icons') then
					str = tostring(texture..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				else
					str = tostring(_text..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				end
				displayString = displayString..str
			end
		end
	else
		if GetOption('firstaid') then
			str = tostring(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\spell_holy_sealofsacrifice').._hex.."N/A".._hex.."|r  ")
			displayString = displayString..str
		end
	end
	if fishing ~= nil then
		local name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset = GetProfessionInfo(fishing)
		if maxRank ~= nil then
			p6 = {name, icon, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier, specializationIndex, specializationOffset}
			if GetOption('fishing') then  -- if(i ~= 1) then _text = " " else _text = "" end
				local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
				words = { strsplit(" ", name) }
				for _, word in ipairs(words) do
					_text = _text .. string.sub(word,1,3)
				end
				if GetOption('icons') then
					str = tostring(texture..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				else
					str = tostring(_text..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
				end
				displayString = displayString..str
			end
		end
	else
		if GetOption('fishing') then
			str = tostring(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\trade_fishing').._hex.."N/A".._hex.."|r  ")
			displayString = displayString..str
		end
	end
	
	if not GetOption('prof1') and not GetOption('prof2') and not GetOption('archaeology') and not GetOption('cooking') and not GetOption('firstaid') and not GetOption('fishing') then
		-- str = tostring("ElvUI ".._hex.."Compact Professions|r")
		displayString = tostring("ElvUI ".._hex.."Compact Professions|r")
	end
	
--[[ part of old script, keeping this here in case it might still come in handy 
		if(i ~= 1) then _text = " " else _text = "" end
		local texture = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', icon)
		words = { strsplit(" ", name) }
		for _, word in ipairs(words) do
			_text = _text .. string.sub(word,1,1)
		end
		local str
--		if labelType == 1 then
--			str = tostring(_text..": ".._hex..count.."|r")
--		elseif labelType == 2 then
			str = tostring(texture..":"..ColorValue(name, GetBonusRace(name, 1), GetBonusRace(name, 2), rank, maxRank, SkillCap)..rank.."/"..maxRank.._hex.."|r  ")
--		elseif labelType == 3 then
--			str = tostring(texture.." ".._text..": ".._hex..count.."|r")
--		end
		displayString = displayString..str

--	elseif i == 1 and not name and not rank then 
--		displayString = tostring(_hex.."---") end ]]

	if self then 
		self.text:SetFormattedText(displayString)
	end
	displayString = "---"
end

local function OnEnter(self)
	local r1, g1, b1, r2, g2, b2 = HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b;
	DT:SetupTooltip(self)
	if not GetOption('prof1') then
		local SkillStr
		if p1[3] == 0 and p1[4] == 0 then SkillStr = "Not Learned"
		else SkillStr = p1[3].."/"..p1[4]
		end
		DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', p1[2]).." "..p1[1], SkillStr, r1, g1, b1, r2, g2, b2)
	end
	if not GetOption('prof2') then
		local SkillStr
		if p2[3] == 0 and p2[4] == 0 then SkillStr = "Not Learned"
		else SkillStr = p2[3].."/"..p2[4]
		end
		DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', p2[2]).." "..p2[1], SkillStr, r1, g1, b1, r2, g2, b2)
	end
	if not GetOption('archaeology') then
		local SkillStr
		if p3[3] == 0 and p3[4] == 0 then SkillStr = "Not Learned"
		else SkillStr = p3[3].."/"..p3[4]
		end
		DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', p3[2]).." "..p3[1], SkillStr, r1, g1, b1, r2, g2, b2)
	end
	if not GetOption('cooking') then
		local SkillStr
		if p4[3] == 0 and p4[4] == 0 then SkillStr = "Not Learned"
		else SkillStr = p4[3].."/"..p4[4]
		end
		DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', p4[2]).." "..p4[1], SkillStr, r1, g1, b1, r2, g2, b2)
	end
	if not GetOption('firstaid') then
		local SkillStr
		if p5[3] == 0 and p5[4] == 0 then SkillStr = "Not Learned"
		else SkillStr = p5[3].."/"..p5[4]
		end
		DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', p5[2]).." "..p5[1], SkillStr, r1, g1, b1, r2, g2, b2)
	end
	if not GetOption('fishing') then
		local SkillStr
		if p6[3] == 0 and p6[4] == 0 then SkillStr = "Not Learned"
		else SkillStr = p6[3].."/"..p6[4]
		end
		DT.tooltip:AddDoubleLine(format('|T%s:14:14:0:0:64:64:4:60:4:60|t', p6[2]).." "..p6[1], SkillStr, r1, g1, b1, r2, g2, b2)
	end
	if not GetOption('prof1') or not GetOption('prof2') or not GetOption('archaeology') or not GetOption('cooking') or not GetOption('firstaid') or not GetOption('fishing') then
		DT.tooltip:AddLine("  ");
	end
	DT.tooltip:AddDoubleLine("Right-Click:", "Opens Datatext Options Menu", r1, g1, b1, r2, g2, b2)
	if lastPanel ~= nil then
		OnEvent(lastPanel)
	end
	DT.tooltip:Show()
end

local function OnClick(self, btn)
	if btn == "RightButton" then
		DT.tooltip:Hide();
		EasyMenu(menu, menuFrame, self, -2, -3, 'MENU', 3)
	end
end

local function ValueColorUpdate(hex, r, g, b)
	_hex = hex
	if lastPanel ~= nil then
		OnEvent(lastPanel)
	end
end
E['valueColorUpdateFuncs'][ValueColorUpdate] = true

DT:RegisterDatatext('ProfessionsCompact', {"PLAYER_ENTERING_WORLD", "SKILL_LINES_CHANGED", "BAG_UPDATE"}, OnEvent, nil, OnClick, OnEnter)  hooksecurefunc("BackpackTokenFrame_Update", function(...) OnEvent(lastPanel) end)