local E, L, V, P, G, _ =  unpack(ElvUI);
local DT = E:GetModule('DataTexts')

local SkillName, SkillModifier, SkillLevel, SkillMaxLevel
local lastPanel;
local race = E.myrace
local SkillCap = 800;
local _hex
local profession, ProfAbbr, BonusRace, Racial = "Cooking", "Cook", 'Pandaren', 15;
local icon = format('|T%s:14:14:0:0:64:64:4:60:4:60|t', 'Interface\\Icons\\inv_misc_food_15')
local red = "|cffc74040"
local orange = "|cffda8c4f"

--[[local v, b, d, t = GetBuildInfo()
if b == "19103" then
	SkillCap = 600
else
	SkillCap = 700
end ]]

local function GetProfInfo(Max, num)
	local id, n
	local r = 0
	if race == BonusRace then r = 15 end
	if Max == (75+r) then
		id = 2550
		n = "Apprentice Cook"
	elseif Max == (150+r) then
		id = 3102
		n = "Journeyman Cook"
	elseif Max == (225+r) then
		id = 3413
		n = "Expert Cook"
	elseif Max == (300+r) then
		id = 18260
		n = "Artisan Cook"
	elseif Max == (375+r) then
		id = 33359
		n = "Master Cook"
	elseif Max == (450+r) then
		id = 51296
		n = "Grand Master Cook"
	elseif Max == (525+r) then
		id = 88053
		n = "Illustrious Grand Master Cook"
	elseif Max == (600+r) then
		id = 104381
		n = "Zen Master Cook"
	elseif Max == 700 then
		id = 158765
		n = "Draenor Cook"
	elseif Max == 800 then
		id = 195128
		n = "Legion Cook"
	end
	
	if num == 1 then
		if id then return GetSpellDescription(id)
		else return "N/A" end
	elseif num == 2 then
		if n ~= nil or n ~= "" then return n
		else return "N/A" end
	end
end

local function OnEvent(self, event, ...)
	local _, _, archaeology, fishing, cooking, firstAid = GetProfessions()
	local profs = {archaeology, fishing, cooking, firstAid}
	for k, v in pairs(profs) do
		local name, texture, rank, maxRank, numSpells, spelloffset, skillLine, rankModifier = GetProfessionInfo(v)
		if name == profession then
			SkillName = name
			SkillLevel = rank
			SkillMaxLevel = maxRank

			if rankModifier == nil or rankModifier == 0 then
				SkillModifier = 0
			else
				SkillModifier = rankModifier
			end
		end
	end	
	
	if SkillMaxLevel ~= nil then
		if (race == BonusRace and SkillLevel >= (SkillMaxLevel - Racial) - 25 and (SkillMaxLevel + Racial) < (SkillCap + Racial)) or (SkillLevel >= SkillMaxLevel - 25 and SkillMaxLevel < SkillCap) then
			if SkillModifier > 0 then
				self.text:SetFormattedText("%s: "..red.."(+%s) %s/%s", icon, SkillModifier, SkillLevel, SkillMaxLevel)
			else
				self.text:SetFormattedText("%s: "..red.."%s/%s", icon, SkillLevel, SkillMaxLevel)
			end
		else -- otherwise keep bar default color
			if SkillModifier > 0 then
				self.text:SetFormattedText("%s ".._hex.."(+%s) %s/%s", icon, SkillModifier, SkillLevel, SkillMaxLevel)
			else
				self.text:SetFormattedText("%s ".._hex.."%s/%s", icon, SkillLevel, SkillMaxLevel)
			end
		end
		
	else
		self.text:SetFormattedText("|cffFFFFFF%s:|r".._hex.." N/A", icon);
	end
	
	if InCombatLockdown() == true then
		DT.tooltip:Hide()
	end
	
	lastPanel = self
end

local function OnEnter(self)
	local r1, g1, b1, r2, g2, b2 = HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b;
	if SkillMaxLevel == nil then
		DT:SetupTooltip(self)
		DT.tooltip:AddLine(format("|cffFFFFFFYou have not learned %s|r", profession), r2, g2, b2)
		DT.tooltip:Show()
	else
		DT:SetupTooltip(self)
		DT.tooltip:AddLine(format("%s %s", icon, profession), r1, g1, b1)
		DT.tooltip:AddLine(format("%s", GetProfInfo(SkillMaxLevel, 1)), r2, g2, b2, true);
		DT.tooltip:AddLine(" ");
		
		DT.tooltip:AddDoubleLine("Skill Mastery:", GetProfInfo(SkillMaxLevel, 2), r1, g1, b1, r2, g2, b2);
		DT.tooltip:AddDoubleLine("Skill Cap:", format("%d", SkillCap), r1, g1, b1, r2, g2, b2);
		DT.tooltip:AddDoubleLine("Skill Level / Max Level:", format("%d / %d", SkillLevel, SkillMaxLevel), r1, g1, b1, r2, g2, b2);
		if race == BonusRace and Racial > 0 then
			DT.tooltip:AddDoubleLine("Racial Skill Bonus:", format("+%d", Racial), r1, g1, b1, r2, g2, b2)
		end
		if SkillModifier > 0 then
			DT.tooltip:AddDoubleLine("Skill Modifier:", format("+%d", SkillModifier), r1, g1, b1, r2, g2, b2)
		end
		
		DT.tooltip:AddLine(" ");
		DT.tooltip:AddDoubleLine("Click:", "Toggle profession interface", r1, g1, b1, r2, g2, b2)

		if InCombatLockdown() == true then
			DT.tooltip:Hide()
		--	return;
		else 
			DT.tooltip:Show()
		end
	end
end

local function OnClick(self)
	local p = profession
	CastSpellByName(p);
end

local function ValueColorUpdate(hex, r, g, b)
	_hex = hex
	if lastPanel ~= nil then
		OnEvent(lastPanel)
	end
end
E["valueColorUpdateFuncs"][ValueColorUpdate] = true

DT:RegisterDatatext('Prof Cooking', {"PLAYER_ENTERING_WORLD", "SKILL_LINES_CHANGED", "BAG_UPDATE"}, OnEvent, nil, OnClick, OnEnter)